SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'content catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:36'!
createWithcatalogue: aCatalogue
 	| cartToReturn |
	cartToReturn := self new.
	^cartToReturn initializeWithCatalogue: aCatalogue. ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Anonymous 6/3/2013 18:27'!
add: aBook
	( catalogue keys includes: aBook ) ifFalse: [self error:'$NOT IN CATALOGUE$'.].
	^content add: aBook ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:23'!
catalogue
	^ catalogue copy.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:23'!
elements 
	^content copy.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:31'!
hasItem: aBook
	^ content includes: aBook.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 18:27'!
hasItemInCatalog:anItem

^ catalogue keys  includes: anItem.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Anonymous 6/3/2013 18:26'!
initialize 
	catalogue := Dictionary new.
	content:= Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:13'!
initializeWithCatalogue: aCatalogue
	catalogue := aCatalogue.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:43'!
isEmpty
	^content size = 0.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 19:23'!
numberofCartElements
	^ content size.! !

Object subclass: #Cashier
	instanceVariableNames: 'priceCatalog salesBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:34'!
calculateTotalofCart: aCart
	| cartContent price |
	cartContent := aCart elements.
	price := 0.
"	cartContent
		collect: [ :anElement | price := price + (aCart catalogue at: anElement * (cartContent occurrencesOf: anElement)) ].
"	^cartContent sum: [ :anElement | (aCart catalogue at: anElement)  * (cartContent occurrencesOf: anElement)].! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:36'!
checkout: aCart
	(aCart isEmpty )ifTrue:[self error: ' $CANNOT CHECKOUT AN EMPTY CART$']
	""! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 21:07'!
checkout: aCart with: aCreditCard onDate: aDate
	(aCart isEmpty )ifTrue:[self error: ' $CANNOT CHECKOUT AN EMPTY CART$'].
	(aCreditCard expiration < aDate )ifTrue:[self error: ' $CANNOT CHECKOUT WITH EXPIRED CREDIT CARD$'].! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:54'!
initialize 
priceCatalog := Dictionary new.
salesBook := Set new.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:57'!
salesBook
	^salesBook copy.! !

Object subclass: #CreditCard
	instanceVariableNames: 'expiration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!CreditCard methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 21:12'!
expiration
	^expiration ! !

Object subclass: #Sale
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Sale methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:53'!
initializeWithElements: aSet andTotal: aNumber onDate: aDate by: aCashier
	! !

Object subclass: #TarjetaDeCreditoREPRESENTARPLASTICO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 19:16'!
createCartWithAnElementInCatalog:anElement andPrice: aPrice 
| aCart  aCtalogue aPriceListItem |

      aCart := Cart new.
	
	aCtalogue:= Dictionary new.
	aPriceListItem := Association new.
	aPriceListItem key: anElement value: aPrice. 
	aCtalogue add: aPriceListItem.
	aCart initializeWithCatalogue: aCtalogue.
	^ aCart.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'FacundoPippia 5/29/2013 20:56'!
test01newCartMustBeEmptyOnCreation

	| aCart |
	aCart := Cart new.
	self assert: aCart isEmpty.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'tuVieja 6/3/2013 18:30'!
test03cartMustNotBeEmptyAfterAddingABook
	
	|aCart aCatalog aPriceListItem |
	
	aCart := Cart new.
	aCatalog:= Dictionary new.
	aPriceListItem := Association new.
	aPriceListItem key: 'LOTR'  value: 5 .
	aCatalog add: aPriceListItem.
	aCart initializeWithCatalogue: aCatalog.
	aCart add: 'LOTR'.
	self deny: aCart isEmpty.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'FacundoPippia 5/29/2013 21:10'!
test04cannotAddBookIfItIsNotPresentInCatalogue
	
	|aCart aBook|
	
	aCart := Cart new.
	
	aBook := 'LOTR'.
	
	
	self should: [ aCart add: aBook. self assert: (aCart hasItem: aBook) .] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = '$NOT IN CATALOGUE$' ].

	! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'tuVieja 6/3/2013 18:32'!
test05OnlyAddedBookMustBeInCartAfterAddition
	
	|aCart aBook aCatalog aPriceListItem |
	
	aCart := Cart new.
	aBook := 'LOTR'.
	aCatalog:= Dictionary new.
	aPriceListItem := Association new.
	aPriceListItem key: aBook value: 5. 
	aCatalog add: aPriceListItem.
	aCart initializeWithCatalogue: aCatalog.
	aCart add: aBook.

	self assert: (aCart hasItem: aBook).
	self assert:( aCart numberofCartElements = 1 ).! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'tuVieja 6/3/2013 21:11'!
test06cannotCheckoutAnEmptyCart
	| aCart aCashier aSalesBookBeforeSale aCreditCard aDate |
	aCart := Cart new.
	aCashier := Cashier new.
	aCreditCard := CreditCard new.
	aDate := Date new.
	aSalesBookBeforeSale := aCashier salesBook.
	self should: [ aCashier checkout: aCart with: aCreditCard onDate: aDate.] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText = ' $CANNOT CHECKOUT AN EMPTY CART$' ) ].
	self assert: aSalesBookBeforeSale = (aCashier salesBook).! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'tuVieja 6/3/2013 20:39'!
test07calculationForSingleElementCartReturnsElementsPrice
	"NEED FOR BETTER NAME"
	| aCashier aCart |
	aCart := self createCartWithAnElementInCatalog:'LOTR' andPrice: 5. 
	aCart add:'LOTR'.
	aCashier := Cashier new.
	self assert:( (aCashier calculateTotalofCart: aCart) = 5 ).
	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:42'!
test08cannotSellWithAnEmptyCreditCard! !
